<?php
include_once("utils_gen_config.php");


function gen_config_cisco_internet_lokalny($s_params)
{
    $ip_p2p=str_replace('/30','',$s_params['ip_p2p']);
    $ip_p2p=str_replace('/29','',$ip_p2p);
    $ip_p2p_mask_cisco=trim(get_ip_p2p_mask($s_params['ip_p2p']));
    $ip_p2p_1=trim(get_ip_p2p_1($s_params['ip_p2p']));
    $ip_p2p_2=trim(get_ip_p2p_2($s_params['ip_p2p']));
    $ip_pa=   get_ip_pa($s_params['ip_pa']);
    $download=trim(get_download($s_params['pasmo']));
    $burst_d=(int)($download/10);
    $upload=  trim(get_upload($s_params['pasmo']));
    $burst_u=(int)($upload/10);
        
    $conf='';
    $conf.="!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n\n";
    $conf.="!!!! Router CISCO B -- ".$s_params['ip_a']." --- ".$s_params['router_a']."\n\n";
        
    $conf.="interface ".$s_params['interface_a'].'.'.$s_params['s_unit']."\n";
    $conf.="    description ".$s_params['description_a']."\n";
    $conf.="    encapsulation dot1q ".$s_params['c_vlan']."\n";
    //$conf.="    mtu 9018"."\n";
    $conf.="    ipv4 address ".$ip_p2p_1." 255.255.255.252"."\n";
    $conf.="    service-policy input ". $s_params['nazwa_uslugi']."_IN"."\n";
    $conf.="    service-policy output ".$s_params['nazwa_uslugi']."_OUT"."\n";
    $conf.="    ipv4 access-group ". $s_params['nazwa_uslugi']."_IN ingress"."\n";
    $conf.="    ipv4 access-group  ".$s_params['nazwa_uslugi']."_OUT egress"."\n";
    $conf.="exit"."\n";
    $conf.="\n\n";
    
    $conf.="policy-map ".$s_params['nazwa_uslugi']."_IN"."\n";
    $conf.="    class class-default"."\n";
    $conf.="    police rate ".$download." mbps"."\n";
    $conf.="end-policy-map"."\n";
    $conf.="\n\n";
    
    $conf.="policy-map ".$s_params['nazwa_uslugi']."_OUT"."\n";
    $conf.="    class class-default"."\n";
    $conf.="    police rate ".$upload." mbps"."\n";
    $conf.="end-policy-map"."\n";
    $conf.="\n\n";
    
    $conf.="!!!!! B2B - access list IN"."\n";
    $conf.="ipv4 access-list ".$s_params['nazwa_uslugi']."_IN"."\n";
    $conf.="    permit icmp any host ".$ip_p2p_1."\n";
    $conf.="    deny tcp any host ".$ip_p2p_1."\n";
    //$conf.="    deny udp any host ".$ip_p2p_1." eq snmp"."\n";
    $conf.="    deny ipv4 any 10.0.0.0 0.255.255.255"."\n";
    $conf.="    deny ipv4 any 192.168.0.0 0.0.255.255"."\n";
    $conf.="    deny ipv4 any 172.16.0.0 0.15.255.255"."\n";
    $conf.="    permit ipv4 ".$ip_p2p." 0.0.0.3 any"."\n";
    $conf.="exit"."\n";
        
    if(count($ip_pa) >0)
    {
        if($ip_pa[0] !== '')
            $conf.="!!!! B2B - adresacja PA"."\n";
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="permit ipv4 ".trim(str_replace(' ','',$ip_pa[$i]))." 0.0.0.7"." any"."\n";
        }
    }
    $conf.="    deny ipv4 any any"."\n";
    $conf.="\n\n";

    $conf.="!!!!! B2B - access list OUT"."\n";
    $conf.="ipv4 access-list ".$s_params['nazwa_uslugi']."_OUT"."\n";
    $conf.="    permit ipv4 any ".$ip_p2p.' 0.0.0.3'."\n";    
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="  permit ipv4 ".$ip_pa.' 0.0.0.7'." any"."\n";  //do przeliczenia maska odwrotna dla ip pa
        }
    }
    $conf.="    deny ipv4 any any"."\n";
    $conf.="\n\n";

    if(count($ip_pa) >0)
    {
        if($ip_pa[0] !== '')
            $conf.="!!!! B2B - adresacja PA"."\n";
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
            {
                $conf.="router static"."\n";
                $conf.="address-family ipv4 unicast"."\n";
                $conf.=trim(str_replace(' ','',$ip_pa[$i])).' '.$ip_p2p_2." description ".$s_params['nazwa_uslugi']."\n";
            }
        }
    }

    //czasem ospf
    $conf.="!!! Czasem rozgloszenie przez OSPF - nalezy sprawdzic na konkretnym routerze"."\n";
    $conf.="router ospf 10"."\n";
    $conf.="  area 0"."\n";
    $conf.="   interface ".$s_params['interface_a'].".".$s_params['s_unit']."\n";
    $conf.="exit"."\n";
    $conf.="exit"."\n";

    $conf.="\n\n";
    
    return $conf;
}

function gen_config_cisco($s_params)
{
    $download=trim(get_download($s_params['pasmo']));
    $upload=  trim(get_upload($s_params['pasmo']));    
    
    $conf='';
    $conf.="!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n\n";
    $conf.="!!!! Router CISCO B -- ".$s_params['ip_b']." --- ".$s_params['router_b']."\n\n";
    
    $s_vlan=$s_params['s_vlan'];
    if($s_params['s_vlan']==='') $s_vlan=$s_params['c_vlan']; //konieczne dla zwyklego tranytu
    $conf.="interface ".$s_params['interface_b'].'.'.$s_vlan." l2transport"."\n";
    $conf.="    description Biznes_L2VPN_Warszawa_B2B_do_Pereca"."\n";
    $conf.="    encapsulation dot1q ".$s_params['c_vlan']."\n";
    $conf.="    mtu 9018"."\n";
    //$conf.="    rewrite ingress tag pop 1 symmetric"."\n";
    //$conf.="    service-policy input ".$s_params['nazwa_uslugi']."_IN"."\n";
    //$conf.="    service-policy output ".$s_params['nazwa_uslugi']."_OUT"."\n";
    $conf.="exit"."\n";
    $conf.="\n\n";
    
    $conf.="l2vpn"."\n";
    $conf.="    pw-class ptp_B2B_vlan_".$s_vlan."\n";
    $conf.="    encapsulation mpls"."\n";
    $conf.="    control-word"."\n";
    $conf.="    protocol ldp"."\n";
    $conf.="    transport-mode vlan"."\n";
    $conf.="exit"."\n";
    
    $conf.="l2vpn"."\n";
    $conf.="    xconnect group ptp_B2B_vlan_".$s_vlan."\n";
    $conf.="    p2p ptp_B2B_vlan_".$s_vlan."\n";
    $conf.="    interface ".$s_params['interface_b'].'.'.$s_vlan."\n";
    $conf.="    neighbor ipv4 89.228.0.50 pw-id ".$s_vlan."\n";
    $conf.="        pw-class ptp_B2B_vlan_".$s_vlan."\n";
    $conf.="        exit"."\n";
    $conf.="    exit"."\n";
    $conf.="exit"."\n";
    $conf.="exit"."\n";
    $conf.="\n\n";
    
    return $conf;
}

