<?php
include_once("utils_gen_config.php");


function gen_config_juniper_internet_lokalny($s_params)
{
    $ip_p2p=str_replace('/30','',$s_params['ip_p2p']);
    $ip_p2p=str_replace('/29','',$ip_p2p);
    $ip_p2p_mask=trim(get_ip_p2p_mask($s_params['ip_p2p']));
    $ip_p2p_1=trim(get_ip_p2p_1($s_params['ip_p2p']));
    $ip_p2p_2=trim(get_ip_p2p_2($s_params['ip_p2p']));
    $ip_pa=   get_ip_pa($s_params['ip_pa']);
    $download=trim(get_download($s_params['pasmo']));
    $burst_d=(int)($download/10);
    $upload=  trim(get_upload($s_params['pasmo']));
    $burst_u=(int)($upload/10);
    
    $conf='';
    $conf.="#####################################################################"."\n";
    $conf.="##### B2B -- ".$s_params['miasto_a']."  ---  ".$s_params['ip_a']." --- ".$s_params['router_a']."\n\n";
    $conf.="##### B2B - Interface"."\n\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." description ".$s_params['description_a']."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." vlan-id ".$s_params['c_vlan']."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet filter input ".$s_params['nazwa_uslugi']."_acl_in"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet filter output ".$s_params['nazwa_uslugi']."_acl_out"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet policer input ".$s_params['nazwa_uslugi']."-IN"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet policer output ".$s_params['nazwa_uslugi']."-OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet address ".$ip_p2p_1."/".$ip_p2p_mask."\n";

    $conf.="\n";
    $conf.="##### B2B - filtr IN"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from protocol icmp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 then accept"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from protocol tcp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 192.168.0.0/16"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 172.16.0.0/12"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 10.0.0.0/8"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 from source-address ".$s_params['ip_p2p']."\n";
    if(count($ip_pa) >0)
    {
        $conf.="\n";
        if($ip_pa[0] !== '')
            $conf.="##### B2B - adresacja PA"."\n";
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 from source-address ".trim(str_replace(' ','',$ip_pa[$i]))."\n";
        }
    }
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 then dscp 0"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 then accept"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T5 then discard"."\n";
    
    $conf.="\n";
    $conf.="##### B2B - filtr OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 from destination-address ".$s_params['ip_p2p']."\n";
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 from destination-address ".trim(str_replace(' ','',$ip_pa[$i]))."\n";
        }
    }
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 then accept"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T2 then discard"."\n";
    $conf.="\n\n";    

    $conf.="##### B2B - policer"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding bandwidth-limit ".$download."m"."\n";
    if($burst_d !== 0) $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding burst-size-limit ".$burst_d."m"."\n";
    else $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding burst-size-limit ".'1'."m"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding bandwidth-limit ".$upload."m"."\n";
    if($burst_u !== 0) $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding burst-size-limit ".$burst_u."m"."\n";
    else $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding burst-size-limit ".'1'."m"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT then discard"."\n";
    
    //STATIC ROUTE dla PA
    $conf.="\n";
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {
            if($s_params['router_a']==='89.228.0.140')
            {
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." routing-options static route ".trim(str_replace(' ','',$ip_pa[$i]))." next-hop ".$ip_p2p_2."\n";
                }
            } else
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." routing-options static route ".trim(str_replace(' ','',$ip_pa[$i]))." next-hop ".$ip_p2p_2."\n";
                }
        }
    }

    $conf.="\n";
    //OSPF
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {        
            //$conf.="\n";
            if($s_params['router_a']==='89.228.0.140')
            {
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement BGP_STATIC term static from route-filter ".trim(str_replace(' ','',$ip_pa[$i]))." orlonger"."\n";
                }
            } else
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement CONNECT_OSPF from route-filter ".trim(str_replace(' ','',$ip_pa[$i]))." exact"."\n"; //dla routera na Pereca 192.168.168.1
                    //$conf.="set ".$s_params['logical_system_a']." policy-options policy-statement STATIC_OSPF term T1 from route-filter ".trim(str_replace(' ','',$ip_pa[$i]))." orlonger"."\n";  //dla routera na Pereca 192.168.168.1
                }
        }
    }
    
    $conf.="\n";    
    #Dla routera PERECA 192.168.168.1
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement CONNECT_OSPF from route-filter ".$s_params['ip_p2p']." exact"."\n";
    
    $conf.="#set ".$s_params['logical_system_a']." policy-options policy-statement STATIC_OSPF term T1 from route-filter ".$s_params['ip_p2p']." orlonger"."\n";  //dla routera na Pereca 192.168.168.1
        
    return $conf;
}

function gen_config_juniper_a_lokalny_bgp($s_params)
{
    $ip_p2p=str_replace('/30','',$s_params['ip_p2p']);
    $ip_p2p=str_replace('/29','',$ip_p2p);
    $ip_p2p_mask=trim(get_ip_p2p_mask($s_params['ip_p2p']));
    $ip_p2p_1=trim(get_ip_p2p_1($s_params['ip_p2p']));
    $ip_p2p_2=trim(get_ip_p2p_2($s_params['ip_p2p']));
    //$ip_pa=   get_ip_pa($s_params['ip_pa']);  //w przypadku BGP adresy PA nie powinny istniec
    $ip_pi=   get_ip_pi($s_params['ip_pi']);
    
    $download=trim(get_download($s_params['pasmo']));
    $burst_d=(int)($download/10);
    $upload=  trim(get_upload($s_params['pasmo']));
    $burst_u=(int)($upload/10);
    
    //Normalna konfiguracja dla polaczeniowki
    $conf='';
    $conf.="#####################################################################"."\n";
    $conf.="##### B2B -- ".$s_params['miasto_a']."  ---  ".$s_params['ip_a']." --- ".$s_params['router_a']."\n\n";
    $conf.="##### B2B - Interface"."\n\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." description ".$s_params['description_a']."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." vlan-tags outer ".$s_params['s_vlan']." inner ".$s_params['c_vlan']."\n";
    $conf.="###set interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." vlan-id ".$s_params['c_vlan']."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet filter input ".$s_params['nazwa_uslugi']."_acl_in"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet filter output ".$s_params['nazwa_uslugi']."_acl_out"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet policer input ".$s_params['nazwa_uslugi']."-IN"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet policer output ".$s_params['nazwa_uslugi']."-OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet address ".$ip_p2p_1."/".$ip_p2p_mask."\n";
    
    $conf.="\n";
    $conf.="##### B2B - filtr IN"."\n\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from source-address ".$ip_p2p_2."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from protocol icmp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 then accept"."\n";

    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from source-address ".$ip_p2p_2."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from protocol tcp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from port bgp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 then accept"."\n";
    
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 192.168.0.0/16"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 172.16.0.0/12"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 10.0.0.0/8"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 then discard"."\n";
    
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 from source-address ".$s_params['ip_p2p']."\n";
    //###########################################################################################################################################################################################
    
    if(count($ip_pi) >0)
    {
        //$conf.="\n";
        if($ip_pi[0] !== '')
            $conf.="##### B2B - adresacja PI"."\n";
        for($i=0;$i<count($ip_pi);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pi[$i])) !== '') $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 from source-address ".trim(str_replace(' ','',$ip_pi[$i]))."\n";
        }
    }
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 then dscp 0"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 then accept"."\n";
    
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T5 then discard"."\n";
    
    $conf.="\n";
    $conf.="##### B2B - filtr OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 from destination-address ".$s_params['ip_p2p']."\n";
    if(count($ip_pi) >0)
    {
        for($i=0;$i<count($ip_pi);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pi[$i])) !== '')
                $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 from destination-address ".trim(str_replace(' ','',$ip_pi[$i]))."\n";
        }
    }
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 then accept"."\n";
    
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T2 then discard"."\n";
    $conf.="\n\n";    

    $conf.="##### B2B - policer"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding bandwidth-limit ".$download."m"."\n";
    if($burst_d !== 0) $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding burst-size-limit ".$burst_d."m"."\n";
    else $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding burst-size-limit ".'1'."m"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding bandwidth-limit ".$upload."m"."\n";
    if($burst_u !== 0) $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding burst-size-limit ".$burst_u."m"."\n";
    else $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding burst-size-limit ".'1'."m"."\n";    
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT then discard"."\n";
    
    //BGP config
    $conf.="\n";
    //filtry IN BGP
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term 1 from as-path "."as_path_".$s_params['nazwa_uslugi']."\n";
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term 1 from prefix-list "."prefix_list_".$s_params['nazwa_uslugi']."\n";
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term 1 then local-preference 300 "."\n";    
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term 2 then reject "."\n";

    //FlowSpec
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term flowspec_import from ".'rib inetflow.0';
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term flowspec_import  then accept";

    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term flowspec_import from "." route-filter ".trim(str_replace(' ','',$ip_pa[$i])).' prefix-length-range /32-/32';
        }
    }

    if(count($ip_pi) >0)
    {
        for($i=0;$i<count($ip_pi);$i++)
        {        
            $conf.="\n";
            if(trim(str_replace(' ','',$ip_pi[$i])) !== '')
            {
                $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term flowspec_import from "." route-filter ".trim(str_replace(' ','',$ip_pi[$i])).' prefix-length-range /32-/32';
            }
        }
    }    
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term "." Blackhole then community add no-export";
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term "." Blackhole then next-hop ".'172.17.17.1';
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term "." Blackhole then accept";
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-IN term "." Blackhole then reject";
    
    //filtr OUT BGP
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-OUT term 1 from route-filter "."0.0.0.0/0"."\n";  //default route
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-OUT term 1 then accept "."\n";
    
    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement ".$s_params['nazwa_uslugi']."-OUT term default then reject "."\n";
    
    if(count($ip_pi) >0)
    {
        for($i=0;$i<count($ip_pi);$i++)
        {        
            $conf.="\n";
            if(trim(str_replace(' ','',$ip_pi[$i])) !== '')
            {
                $conf.="set ".$s_params['logical_system_a']." policy-options prefix-list policy-statement "."prefix_list_".$s_params['nazwa_uslugi']." ".trim(str_replace(' ','',$ip_pi[$i]))."\n";
            }
        }
    }
    
    $conf.="\n";
    $as_k=trim(str_replace(' ','',$s_params['as_klienta']));
    $as_k_reg='"'.'^'.$as_k.'( '.$as_k.')*$"';                   //"^8834( 8834)*$"
    $conf.="set ".$s_params['logical_system_a']." policy-options as-path "."as_path_".$s_params['nazwa_uslugi']." ".$as_k_reg."\n";
    //lub
    $as_k_reg=$as_k.'+';
    $conf.="#set ".$s_params['logical_system_a']." policy-options as-path "."as_path_".$s_params['nazwa_uslugi']." ".$as_k_reg."\n";
    //lub
    $as_k_reg='".*"';  //all
    $conf.="#set ".$s_params['logical_system_a']." policy-options as-path "."as_path_".$s_params['nazwa_uslugi']." ".$as_k_reg."\n";

    //run BGP
    $conf.="\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." type external"."\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." import ".$s_params['nazwa_uslugi']."-IN"."\n";
    $conf.="#set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." family inet unicast prefix-list maximum 2 "."\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." family inet unicast prefix-list maximum 2 "."\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." export ".$s_params['nazwa_uslugi']."-OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." remove-private"."\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." peer-as ".$as_k."\n";
    $conf.="set ".$s_params['logical_system_a']." protocols bgp group "."BGP_".$s_params['nazwa_uslugi']." neighbor ".$ip_p2p_2."\n";    

    return $conf;
}

/*
 * 
 function gen_config_juniper_internet_lokalny($s_params)
{
    $ip_p2p=str_replace('/30','',$s_params['ip_p2p']);
    $ip_p2p=str_replace('/29','',$ip_p2p);
    $ip_p2p_mask=trim(get_ip_p2p_mask($s_params['ip_p2p']));
    $ip_p2p_1=trim(get_ip_p2p_1($s_params['ip_p2p']));
    $ip_p2p_2=trim(get_ip_p2p_2($s_params['ip_p2p']));
    $ip_pa=   get_ip_pa($s_params['ip_pa']);
    $download=trim(get_download($s_params['pasmo']));
    $burst_d=(int)($download/10);
    $upload=  trim(get_upload($s_params['pasmo']));
    $burst_u=(int)($upload/10);
    
    $conf='';
    $conf.="#####################################################################"."\n";
    $conf.="##### B2B -- ".$s_params['miasto_a']."  ---  ".$s_params['ip_a']." --- ".$s_params['router_a']."\n\n";
    $conf.="##### B2B - Interface"."\n\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." description ".$s_params['description_a']."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." vlan-id ".$s_params['c_vlan']."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet filter input ".$s_params['nazwa_uslugi']."_acl_in"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet filter output ".$s_params['nazwa_uslugi']."_acl_out"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet policer input ".$s_params['nazwa_uslugi']."-IN"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet policer output ".$s_params['nazwa_uslugi']."-OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." interfaces ".$s_params['interface_a']." unit ".$s_params['s_unit']." family inet address ".$ip_p2p_1."/".$ip_p2p_mask."\n";

    $conf.="\n";
    $conf.="##### B2B - filtr IN"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 from protocol icmp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T1 then accept"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from destination-address ".$ip_p2p_1."/32"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 from protocol tcp"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T2 then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 192.168.0.0/16"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 172.16.0.0/12"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 from destination-address 10.0.0.0/8"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T3 then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 from source-address ".$s_params['ip_p2p']."\n";
    if(count($ip_pa) >0)
    {
        $conf.="\n";
        if($ip_pa[0] !== '')
            $conf.="##### B2B - adresacja PA"."\n";
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 from source-address ".trim(str_replace(' ','',$ip_pa[$i]))."\n";
        }
    }
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 then dscp 0"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T4 then accept"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_in term T5 then discard"."\n";
    
    $conf.="\n";
    $conf.="##### B2B - filtr OUT"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 from destination-address ".$s_params['ip_p2p']."\n";
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {        
            if(trim(str_replace(' ','',$ip_pa[$i])) !== '') $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 from destination-address ".trim(str_replace(' ','',$ip_pa[$i]))."\n";
        }
    }
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T1 then accept"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall filter ".$s_params['nazwa_uslugi']."_acl_out term T2 then discard"."\n";
    $conf.="\n\n";    

    $conf.="##### B2B - policer"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding bandwidth-limit ".$download."m"."\n";
    if($burst_d !== 0) $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding burst-size-limit ".$burst_d."m"."\n";
    else $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN if-exceeding burst-size-limit ".'1'."m"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-IN then discard"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding bandwidth-limit ".$upload."m"."\n";
    if($burst_u !== 0) $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding burst-size-limit ".$burst_u."m"."\n";
    else $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT if-exceeding burst-size-limit ".'1'."m"."\n";
    $conf.="set ".$s_params['logical_system_a']." firewall policer ".$s_params['nazwa_uslugi']."-OUT then discard"."\n";
    
    //STATIC ROUTE dla PA
    $conf.="\n";
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {
            if($s_params['router_a']==='89.228.0.140')
            {
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." routing-options static route ".trim(str_replace(' ','',$ip_pa[$i]))." next-hop ".$ip_p2p_2."\n";
                }
            } else
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." routing-options static route ".trim(str_replace(' ','',$ip_pa[$i]))." next-hop ".$ip_p2p_2."\n";
                }
        }
    }

    $conf.="\n";
    //OSPF
    if(count($ip_pa) >0)
    {
        for($i=0;$i<count($ip_pa);$i++)
        {        
            //$conf.="\n";
            if($s_params['router_a']==='89.228.0.140')
            {
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement BGP_STATIC term static from route-filter ".trim(str_replace(' ','',$ip_pa[$i]))." orlonger"."\n";
                }
            } else
                if(trim(str_replace(' ','',$ip_pa[$i])) !== '')
                {
                    $conf.="set ".$s_params['logical_system_a']." policy-options policy-statement STATIC_OSPF term T1 from route-filter ".trim(str_replace(' ','',$ip_pa[$i]))." orlonger"."\n";  //dla routera na Pereca 192.168.168.1
                }
        }
    }
    
    $conf.="\n";    
    #$conf.="set policy-options policy-statement CONNECT_OSPF from route-filter ".$s_params['ip_p2p']." exact"."\n";
 */